<?php
/*
 * Application :GladeXT for Php 
 */


define('TAB',"\t");
//define('TAB','    ');

error_reporting(E_ALL);


/*
 * Debuging : set parameter to TRUE or FALSE
 */
$_debug = TRUE;

/*
 * Loading PHP-GTK extension
 */
if (!class_exists('gtk')) 
{
    if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
    {
        dl('php_gtk.dll');
        $_INI['os']           = 'win';
        $_INI['new_line']     = "\r\n";
        $_INI['folder_sep']   = '\\';         
    }
    else
    {
        dl('php_gtk.so');
        $_INI['os']           = 'lin';
        $_INI['new_line']     = "\n";
        $_INI['folder_sep']   = '/';         
    }
}
else die ('impossible to load PHP-GTK extension');


include_once('gladeXT.func.php');

/*
 *
 *
 *
 */
function on_button_start_clicked( $button )
{
    $_debug         = &$GLOBALS['_debug'];
    $error_message  = &$GLOBALS['error_message'];
    $captures       = &$GLOBALS['captures'];
    $handlers       = &$GLOBALS['handlers'];
    $windows        = &$GLOBALS['windows'];    
    $_INI           = &$GLOBALS['_INI'];    
    $src_path       = &$GLOBALS['src_path'];
    $input_folder   = &$GLOBALS['input_folder'];
    $output_folder  = &$GLOBALS['output_folder'];    
    $software_version = &$GLOBALS['software_version'];
    $software_name    = &$GLOBALS['software_name'];
    
    if(FALSE != $_debug)
        echo "signal clicked called on_button_start_clicked. function is line ".__LINE__."\n";
    
    // at begining there are no error
    $return_value = TRUE;
    
    // cleaning log and showing window;
    clear_log();
    show_window('window_log');
        
    $req = get_form('glade_app_writer');
    
    // getting options for application writer
    $options['write_handlers']  = $req['checkbutton_write_handlers'];
    $options['write_extras']    = $req['checkbutton_write_extras'];
    $options['print_debug']     = $req['checkbutton_print_debug'];
    $options['write_init_app']  = $req['checkbutton_write_init_app'];
    $options['auto_save_log']   = $req['checkbutton_auto_save_log'];
    
    
    
    
    // output path is a folder NO ending slash
    // notice : {auto} will create a folder with app name and use it for copying files

    // extracting paths
    GetPaths($req['entry_glade_file']);
    
    // splash console screen
    add_to_log("$software_name\n");
    add_to_log(TAB.TAB."written by : Jean Philippe Giot, august 2002.\n");
    add_to_log(TAB.TAB."license    : GNU GPL\n");
    add_to_log(TAB.TAB."version    : $software_version\n");
    add_to_log("Start Parameters\n");
    add_to_log(TAB.TAB."given input  : $src_path\n");
    add_to_log(TAB.TAB."input folder : $input_folder \n");
    add_to_log(TAB.TAB."output folder: $output_folder\n");
    
    $current_step = 1;
    
    add_to_log("\n== Step $current_step ==\n"); $current_step++;
    // reseting variables for XML parser and parsing file
    if (
        (FALSE != $return_value) && 
        (FALSE == gladeXmlParserInit())
       ) $return_value = FALSE;

    if (
        (FALSE != $return_value) && 
        (FALSE == gladeXmlParserMain())
       ) $return_value = FALSE;
       
    // end parsing results
    if (FALSE != $return_value)
    {
        add_to_log("PARSING RESULTS\n");
        add_to_log(TAB."project name   : $captures[project_name]\n");
        add_to_log(TAB."windows count  : ".count($windows)."\n");
        add_to_log(TAB."handlers count : ".count($handlers)." handlers found\n");
    }       
    
    // once parsing is done we can create output path
    // notice : {auto} will create a folder with project_name extracted from glade file,
    // will create it and use it for copying files
    add_to_log("\n== Step $current_step ==\n"); $current_step++;
    if (
        (FALSE != $return_value) && 
        (FALSE == MakeOutputPath($req['entry_output_path']))
       ) $return_value = FALSE;
    
    
    // looking for files to copy automatically in dest folder
    add_to_log("\n== Step $current_step ==\n"); $current_step++;
    if (
        (FALSE != $return_value) && 
        (FALSE == lookForLibFiles())
       ) $return_value = FALSE;    
      
    // writing files
    add_to_log("\n== Step $current_step ==\n"); $current_step++;
    if (
        (FALSE != $return_value) && 
        (FALSE == WriteApplicationFile($options))
       ) $return_value = FALSE;
    
    // writing if necessary a windows bat file
    add_to_log("\n== Step $current_step ==\n"); $current_step++;
    if (
        (FALSE != $return_value) &&
        ('win' == $_INI['os']) && 
        (FALSE != $req['checkbutton_write_bat_file']) &&
        (FALSE == WriteBatFile())
       ) $return_value = FALSE;
        
    // copy glade source and includes
    add_to_log("\n== Step $current_step ==\n"); $current_step++;
    if (
        (FALSE != $return_value) && 
        (FALSE == CopyGladeAndIncludes())
       ) $return_value = FALSE;

    auto_save_log();
    
    if (FALSE != $return_value)
    {
        //show_window('window_project_saved');
        dialog_window_popup('End of rendering','The project files are correctly written');
    }
    else 
    {
        dialog_window_popup('ERROR',$error_message);
    }
}


function dialog_window_popup($window_title,$message)
{
    global $glade_app;
    global $_debug;
    
    if(FALSE != $_debug)
        echo "showing dialog window\n";
        
    $window = $glade_app->get_widget('window_error');
    $window->set_title($window_title);
    
    $widget = $glade_app->get_widget('label_dialog_text');
    $widget->set_text($message);
    
    show_window('window_error');
    
    $window->show_all();
}

/*
 *
 *
 *
 */
function on_glade_app_writer_destroy()
{
    quit_app();
}

/*
 *
 *
 *
 */
function on_button_saved_ok_clicked()
{
    hide_window('window_project_saved');
}

/*
 *
 *
 *
 */
function on_button_error_ok_clicked()
{
    hide_window('window_error');
}

/*
 *
 *
 *
 */
function on_window_error_destroy()
{
    hide_window('window_error');
}

/*
 *
 *
 *
 */
function on_window_project_saved_destroy()
{
    hide_window('window_project_saved');
}


/*
 *
 *
 *
 */
function on_about_menu_about_activate()
{
    show_window('window_about');
}


/*
 *
 *
 *
 */
function on_file_menu_quit_activate()
{
    quit_app();
}


/*
 *
 *
 *
 */
function on_button_close_clicked()
{
    hide_window('window_about');
}

/*
 *
 *
 *
 */
function on_window_about_destroy()
{
    hide_window('window_about');
}

/*
 *
 *
 *
 */
function on_button_save_log_clicked()
{
    $form = get_form('window_log');
    
    //save_log("save log to ".$form['entry_save_log_path']."\n");
    
    save_window_form_to_file('glade_app_writer');
}

/*
 *
 *
 *
 */
function on_button_log_close_clicked()
{
    hide_window('window_log');
}

/*
 *
 *
 *
 */
function on_window_log_destroy()
{
    hide_window('window_log');
}

/*
 *  Exit Application
 *
 *
 */
function quit_app()
{
    global $_debug;
    if(FALSE != $_debug)
        echo "Leaving. Bye\n";
    Gtk::main_quit();
}

/*
 *  show window given in parameter
 *
 *
 */
function show_window($window_name)
{
    global $_debug;
    global $glade_app;
    if(FALSE != $_debug)
        echo "showing window $window_name\n";
    $widget = $glade_app->get_widget($window_name);
    $widget->show();
}

/*
 *  Hide Window given in paramter
 *
 *
 */
function hide_window($window_name)
{
    global $_debug;
    global $glade_app;
    if(FALSE != $_debug)
        echo "hiding window $window_name\n";
    $widget = $glade_app->get_widget($window_name);
    $widget->hide();
}


/*
 *  Return an array containing as key all user input widget name
 *
 *
 */
function get_form($window_name)
{
    $_debug    = &$GLOBALS['_debug'];
    $glade_app = &$GLOBALS['glade_app'];
    
    if(FALSE != $_debug)
        echo "getting form values for $window_name window\n";
    
    switch ($window_name)
    {
        case 'glade_app_writer':
        {

            /*
             * getting GtkEntry
             */
            $widget = $glade_app->get_widget('entry_glade_file');
            $ret['entry_glade_file']     = $widget->get_text();
            
            $widget = $glade_app->get_widget('entry_output_path');
            $ret['entry_output_path']    = $widget->get_text();
            

            /*
             * getting GtkCheckButton
             */
            $widget = $glade_app->get_widget('checkbutton_print_debug');
            $ret['checkbutton_print_debug']  = $widget->get_active();
            
            $widget = $glade_app->get_widget('checkbutton_write_extras');
            $ret['checkbutton_write_extras']     = $widget->get_active();
            
            $widget = $glade_app->get_widget('checkbutton_write_bat_file');
            $ret['checkbutton_write_bat_file']   = $widget->get_active();
            
            $widget = $glade_app->get_widget('checkbutton_write_handlers');
            $ret['checkbutton_write_handlers']   = $widget->get_active();
            
            $widget = $glade_app->get_widget('checkbutton_write_init_app');
            $ret['checkbutton_write_init_app']   = $widget->get_active();
            
            $widget = $glade_app->get_widget('checkbutton_auto_save_log');
            $ret['checkbutton_auto_save_log']   = $widget->get_active();            
            
            break;
        }
        case 'window_project_saved':
        {
            break;
        }
        case 'window_error':
        {
            break;
        }
        case 'window_about':
        {

            /*
             * getting GtkEntry
             */
            $widget = $glade_app->get_widget('entry1');
            $ret['entry1']   = $widget->get_text();
            
            break;
        }
        case 'window_log':
        {

            /*
             * getting GtkEntry
             */
            $widget = $glade_app->get_widget('entry_save_log_path');
            $ret['entry_save_log_path']  = $widget->get_text();
            
            break;
        }
        default: break;
    }
    return $ret;
}

/*
 *  Set for a widget it's value contained in given array. only one window 
 *
 *
 */
function set_form($window_name, $widget_values)
{
    $_debug    = &$GLOBALS['_debug'];
    $glade_app = &$GLOBALS['glade_app'];
    
    if(FALSE != $_debug)
        echo "setting widget values for $window_name window\n";
    
    switch ($window_name)
    {
        case 'glade_app_writer':
        {

            /*
             * setting GtkEntry
             */
            $widget = $glade_app->get_widget('entry_glade_file');
            $widget->set_text($widget_values['entry_glade_file']);
            
            $widget = $glade_app->get_widget('entry_output_path');
            $widget->set_text($widget_values['entry_output_path']);
            

            /*
             * setting GtkCheckButton
             */
            $widget = $glade_app->get_widget('checkbutton_print_debug');
            $widget->set_active($widget_values['checkbutton_print_debug']);
            
            $widget = $glade_app->get_widget('checkbutton_write_extras');
            $widget->set_active($widget_values['checkbutton_write_extras']);
            
            $widget = $glade_app->get_widget('checkbutton_write_bat_file');
            $widget->set_active($widget_values['checkbutton_write_bat_file']);
            
            $widget = $glade_app->get_widget('checkbutton_write_handlers');
            $widget->set_active($widget_values['checkbutton_write_handlers']);
            
            break;
        }
        case 'window_project_saved':
        {
            break;
        }
        case 'window_error':
        {
            break;
        }
        case 'window_about':
        {

            /*
             * setting GtkEntry
             */
            $widget = $glade_app->get_widget('entry1');
            $widget->set_text($widget_values['entry1']);
            
            break;
        }
        case 'window_log':
        {

            /*
             * setting GtkEntry
             */
            $widget = $glade_app->get_widget('entry_save_log_path');
            $widget->set_text($widget_values['entry_save_log_path']);
            
            break;
        }
        default: break;
    }
    return $ret;
}

function main()
{
    global $glade_app;
    global $software_release_name;
    // hiding two other windows
    hide_window('window_project_saved');
    hide_window('window_error');    
    hide_window('window_about'); 
    hide_window('window_log');
    
    // changing about label to correspond to correct release name
    
    $label = $glade_app->get_widget('label_release_name');
    $label->set_text($software_release_name);
}

$glade_app = &new GladeXML('gladeXT.glade');
$glade_app->signal_autoconnect();
main();
Gtk::main();
?>