<?php

// declaration of variables used in functions via GLOBALS

$output_folder  = '';
$input_folder   = '';
$src_path       = '';
$src_file       = '';
$appname        = '';
$app_file_name  = '';

$capture_to = '';
$captures   = array
(
    'project_name'      => '',
    'widget_name'       => '',
    'widget_class'      => '',
    'signal_name'       => '',
    'signal_handler'    => ''
);
$handlers   = array();
$handler_p  = 0;
$user_change= array();
$windows    = array();
$trigger    = array
(
    'name'                  => '',
    'on_close_save_signal'  => '',
    'register_user_input'   => '',
    'register_new_window'   => ''
);

$includes   = array();

$software_name          = 'Glade Sourcefile Maker';
$software_version       = '0.2.2';
$software_release_name  = $software_name.' '.$software_version;
$software_url           = 'http://jgiot.free.fr/gladeXT/';

$error_message          = '';

$log_content            = '';

/***************************** GLADE XML PARSER ***************************/

/*
 * initialisation of variables used in XML parser
 */
function gladeXmlParserInit()
{
    $_debug     = &$GLOBALS['_debug'];
    $capture_to = &$GLOBALS['capture_to'];
    $captures   = &$GLOBALS['captures'];
    $trigger    = &$GLOBALS['trigger'];
    $handlers   = &$GLOBALS['handlers'];
    $handler_p  = &$GLOBALS['handler_p'];
    $user_change= &$GLOBALS['user_change'];
    $windows    = &$GLOBALS['windows'];
    
    $capture_to = '';
    $captures   = array
        (
            'project_name'      => '',
            'widget_name'       => '',
            'widget_class'      => '',
            'signal_name'       => '',
            'signal_handler'    => ''
        );
    $handlers   = array();
    $handler_p  = 0;
    $user_change= array();
    $windows    = array();
    $trigger    = array
        (
            'name'                  => '',
            'on_close_save_signal'  => '',
            'register_user_input'   => '',
            'register_new_window'   => ''
        );
        
    return TRUE;
}

/*
 * initialisation of variables used in XML parser
 */
function gladeXmlParserMain()
{
    $_debug     = &$GLOBALS['_debug'];
    $capture_to = &$GLOBALS['capture_to'];
    $captures   = &$GLOBALS['captures'];
    $trigger    = &$GLOBALS['trigger'];
    $handlers   = &$GLOBALS['handlers'];
    $handler_p  = &$GLOBALS['handler_p'];
    $user_change= &$GLOBALS['user_change'];
    $windows    = &$GLOBALS['windows'];
    
    $src_path   = &$GLOBALS['src_path'];
    $error_message  = &$GLOBALS['error_message'];
    
    if (FALSE != $_debug)
        add_to_log("starting parsing glade xml...\n");

    $xml_parser = xml_parser_create();
    xml_set_element_handler($xml_parser, "startElement", "endElement");
    xml_set_character_data_handler($xml_parser, "characterData");
    
    // opening glade file and storing pointer in $fp
    $fp = @fopen($src_path, "r");
    if (FALSE == $fp) 
    {
        $error_message = "could not open XML input : file $src_path\n";
        return FALSE;
    }
    
    // readding and parsing file
    while ($data = fread($fp, 4096)) 
    {
        if (FALSE == xml_parse($xml_parser, $data, feof($fp)))
        {
            $error_message = sprintf("XML error: %s at line %d\n",xml_error_string(xml_get_error_code($xml_parser)),xml_get_current_line_number($xml_parser));
            return FALSE;
        }
    }
    
    // freeing ressources
    xml_parser_free($xml_parser); 
    @fclose($fp);

    if (FALSE != $_debug)
        add_to_log("...done.\n");
        
    return TRUE;
}

// XML parser functions
function startElement($parser, $tagname, $attrs) 
{
    $_debug     = &$GLOBALS['_debug'];
    $capture_to = &$GLOBALS['capture_to'];
    $captures   = &$GLOBALS['captures'];
    $trigger    = &$GLOBALS['trigger'];
    $handlers   = &$GLOBALS['handlers'];
    $handler_p  = &$GLOBALS['handler_p'];
    $user_change= &$GLOBALS['user_change'];
    $windows    = &$GLOBALS['windows'];

    $name = strtolower($tagname);
    
    // here we set where to store data next time characterData is called
    // and also what to trigger if another widget is found
    switch ($name)
    {
        case 'project' : 
        {
            // next name tag will be stored in 
            $trigger['name'] = 'project_name';
            // nothing to store now
            $capture_to = '';
            //echo "next time capturing project name\n";
            break;
        }
        
        case 'widget' : 
        {
            // next name tag will be stored in 
            $trigger['name'] = 'widget_name';
            // nothing to store
            $capture_to = '';
            // we delete old widget name
            $captures['widget_name']='';
            break;
        }
        
        case 'class':
        {
            $capture_to = 'widget_class';
            break;
        }        
        
        case 'signal':
        {
            // next name tag will be stored in 
            $trigger['name'] = 'signal_name';
            $trigger['on_close_save_signal'] = TRUE;
            // nothing to store
            $capture_to = '';            
            break;
        }        
        
        case 'handler':
        {
            $capture_to = 'signal_handler';
            break;
        }

        case 'name':
        {
            $capture_to = $trigger['name'];
            //echo "capturing name for $trigger[name]\n";
            break;
        }
        
        default:
        {
            $capture_to = '';
            break;
        }
    } // end switch       
}


function characterData($parser,$data)
{
    $_debug     = &$GLOBALS['_debug'];
    $capture_to = &$GLOBALS['capture_to'];
    $captures   = &$GLOBALS['captures'];
    $trigger    = &$GLOBALS['trigger'];
    $handlers   = &$GLOBALS['handlers'];
    $handler_p  = &$GLOBALS['handler_p'];
    $user_change= &$GLOBALS['user_change'];
    $windows    = &$GLOBALS['windows'];;
    
    // we capture data in $capture_to
    if( ('' != $capture_to) && (FALSE != $data) )
    {
        $text = trim($data);
        
        if ('' != $capture_to)
        {
            //echo "capturing => $capture_to\n";
            $captures["$capture_to"] = $text;
        }
        
        if (FALSE != $trigger['register_user_input'])
        {
            // we register user input if necessary
            
            if (FALSE != $captures['widget_name'])
            {
                if (FALSE != $_debug) add_to_log('adding '.$captures['widget_class'].' to '.$captures['window_name']." user editable list\n");
                    
                $user_change[$captures['window_name']][$captures['widget_class']][] = $text;
                $trigger['register_user_input'] = '';
            }
            else if (FALSE != $_debug) add_to_log("impossible to register user input, widget_name is missing\n");
        }
        
        if (FALSE != $trigger['register_new_window'])
        {
            // we register new windows in list
            if (FALSE != $_debug) echo "found new window : $text\n";
            $captures['window_name'] = $text;
            $windows[] = $text;
            $trigger['register_new_window']='';
        }        
        
        // then on new widgets, we should examine class datas which are widgets types
        if ('widget_class' == $capture_to)
        {
            switch ($text)
            {
                case 'GtkWindow':
                {
                    // this is the current window
                    // we save it's name next time a name is found
                    $trigger['register_new_window'] = TRUE;
                    $trigger['name'] = 'window_name';
                    break;
                }
                case 'GtkEntry':        // Jump
                case 'GtkRadioButton':  // Jump
                case 'GtkCheckButton':  // Jump
                case 'GtkToggleButton':                
                {
                    // we save it in user input array next time
                    $trigger['register_user_input'] = TRUE;
                    break;
                }
                default:
                {
                    //echo "nothing to do special with $text widget\n";
                    break;
                }
            }
        }     
        
        // cleaning 
        $capture_to = '';
    }
}

function endElement($parser, $tagname) 
{
    $_debug     = &$GLOBALS['_debug'];
    $capture_to = &$GLOBALS['capture_to'];
    $captures   = &$GLOBALS['captures'];
    $trigger    = &$GLOBALS['trigger'];
    $handlers   = &$GLOBALS['handlers'];
    $handler_p  = &$GLOBALS['handler_p'];
    $user_change= &$GLOBALS['user_change'];
    $windows    = &$GLOBALS['windows'];    
    
    switch (strtolower($tagname))
    {
        case 'signal':
        {
            if ( (FALSE != $trigger['on_close_save_signal']) && (FALSE != $captures['signal_handler']) )
            {                
                $handlers[$handler_p]['widget_name']      = $captures['widget_name'];
                $handlers[$handler_p]['widget_class']     = $captures['widget_class'];
                $handlers[$handler_p]['signal_name']      = $captures['signal_name'];
                $handlers[$handler_p]['signal_handler']   = $captures['signal_handler'];
                $handler_p++;      
                
                if (FALSE != $_debug)
                {
                    add_to_log("saving : $handler_p (window : ".$captures['window_name'].")\n");
                    add_to_log("\tcurrent widget\t$captures[widget_name]\n");
                    add_to_log("\twidget class\t$captures[widget_class]\n");
                    add_to_log("\tsignal name\t$captures[signal_name]\n");
                    add_to_log("\tsignal handler\t$captures[signal_handler]\n");
                    add_to_log("\n");
                }

                // cleaning signal values
                $captures['signal_name']='';
                $captures['signal_handler']='';
            }
            break;
        }        
        default:
        {
            break;
        }
    }    
}

/***************************** WRITE FILES ***************************/

/*
 * Looks for files that has the same name as $appname with different extensions 
 * to copy them in output folder
 *
 */
function MakeOutputPath($user_output_folder)
{
    $_debug         = &$GLOBALS['_debug'];
    
    $input_folder   = &$GLOBALS['input_folder'];
    $output_folder  = &$GLOBALS['output_folder'];
    $_INI           = &$GLOBALS['_INI'];
    $captures       = &$GLOBALS['captures'];
    
    // creating folder if $output_folder == '{auto}';
    if ('{auto}' == $user_output_folder)
        $output_folder = $input_folder.$_INI['folder_sep'].$captures['project_name'].$_INI['folder_sep'];
    else 
        $output_folder = $user_output_folder;
        
    if (FALSE == is_dir($output_folder))
    {
        $return_value = CreateFolder($output_folder);
    }
    else 
    {
        if (FALSE != $_debug) add_to_log("folder $output_folder already exists\n");
        $return_value = TRUE;
    }
    return $return_value;
}



/*
 * create a folder
 *
 */
function CreateFolder($folder,$mask = '')
{
    $error_message  = &$GLOBALS['error_message'];    
    if (FALSE == $mask) $mask = '0775';
    $oldumask = umask(0);
    if (FALSE == mkdir($folder, $mask))
    {
        add_to_log('impossible to create destination folder '.$output_folder."!\n");
        $error_message = 'impossible to create destination folder '.$output_folder."!\n";
        $return_value = FALSE;
    }
    else 
    {
        $return_value = TRUE;
        add_to_log('folder '.$output_folder." sucessfully created\n");
    }
    umask($oldumask);
    
    return $return_value;
}


/*
 * extract different files name and path from given glade file path 
 *
 */
function GetPaths($glade_file_path)
{
    $_debug                 = &$GLOBALS['_debug'];
    $_INI                   = &$GLOBALS['_INI'];
    $error_message          = &$GLOBALS['error_message'];
    
    // variables changed by this function
    $src_path               = &$GLOBALS['src_path'];
    $src_file               = &$GLOBALS['src_file'];
    $input_folder           = &$GLOBALS['input_folder'];
    $appname                = &$GLOBALS['appname'];
    $app_file_name          = &$GLOBALS['app_file_name'];
    
    //we extract folder name and filename
    $src_path       = realpath($glade_file_path);  // should work because file exist
    $src_file       = basename($src_path);        
    $input_folder   = dirname($src_path).$_INI['folder_sep'];

    
    // getting app name from glade filename
    $parts = explode('.',$src_file);
    // we take off .glade
    $last = count($parts)-1;
    if ('glade' == $parts[$last])
        unset($parts[$last]);
    $appname = implode('.',$parts);
    // setting main file name
    $app_file_name = $appname.'.app.php';
    
    // if we didn't succed in creating paths, we return false
    if ('' == $appname) 
    {
        $error_message = 'Failed to create path from given informations!'."\n";
        return FALSE;
    }
    else return TRUE;
}

/*
 * Looks for files that has the same name as $appname with different extensions 
 * to copy them in output folder
 *
 */
function lookForLibFiles()
{
    $_debug         = &$GLOBALS['_debug'];
    $appname        = &$GLOBALS['appname'];
    $input_folder   = &$GLOBALS['input_folder'];

    // array modified by this function
    $includes   = &$GLOBALS['includes'];    
    
    $extension[] = '.func.php';
    $extension[] = '.inc.php';
    $extension[] = '.lib.php';
    
    if (FALSE != $_debug) add_to_log("Looking for files to include automatically...\n");
    foreach ($extension as $id => $ext)
    {
        $file = $input_folder.$appname.$ext;
        if (FALSE != $_debug) add_to_log(TAB."File $file ...");
        if (FALSE != is_file($file))
        {
            if (FALSE != $_debug) add_to_log(TAB."found\n");
            $includes[] = $appname.$ext;
        }
        else
            if (FALSE != $_debug) add_to_log(TAB."not found\n");
    }
    return TRUE; 
}


/*
 * Copying original glade file and includes
 */
function CopyGladeAndIncludes()
{
    $_debug        = &$GLOBALS['_debug'];    
    $input_folder  = &$GLOBALS['input_folder'];
    $output_folder = &$GLOBALS['output_folder'];
    $includes      = &$GLOBALS['includes'];
    $src_file      = &$GLOBALS['src_file'];
    $error_message  = &$GLOBALS['error_message'];
    
    if (FALSE != $_debug) add_to_log("Copying glade source file and includes...\n");
    
    $includes[] = $src_file;
    
    foreach ($includes as $id => $filename)
    {
        if (FALSE != $_debug)
        {
            add_to_log('   from : '.$input_folder.$filename."\n");
            add_to_log('   to   : '.$output_folder.$filename."\n");
            add_to_log('    ->  : ');        
        }
        
        if (FALSE == @copy($input_folder.$filename, $output_folder.$filename))
        {
            if (FALSE != $_debug) add_to_log('Error!');
            $error_message = "Failed to copy \n\t".$input_folder.$filename."\nin\n\t".$output_folder.$filename;
            return FALSE;
        }
        else
        {
            if (FALSE != $_debug)
            {
                add_to_log('Ok');
                add_to_log("\n");
            }
        }
    }
    
    return TRUE;
}



/*
 * Writing application file
 *
 */
function WriteApplicationFile($options = array())
{
    $_debug         = &$GLOBALS['_debug'];
    $capture_to     = &$GLOBALS['capture_to'];
    $captures       = &$GLOBALS['captures'];
    $trigger        = &$GLOBALS['trigger'];
    $handlers       = &$GLOBALS['handlers'];
    $handler_p      = &$GLOBALS['handler_p'];
    $user_change    = &$GLOBALS['user_change'];
    $windows        = &$GLOBALS['windows'];
    $error_message  = &$GLOBALS['error_message'];    
    $includes       = &$GLOBALS['includes'];    
    $output_folder  = &$GLOBALS['output_folder'];
    $app_file_name  = &$GLOBALS['app_file_name']; 
    $src_file       = &$GLOBALS['src_file'];  

    add_to_log("Writing Php Application...\n");
    add_to_log(TAB."folder :".$output_folder."\n");
    add_to_log(TAB."file   :".$app_file_name."\n");
    add_to_log(TAB."options :\n");
    foreach ($options as $opt_name => $istrue) add_to_log(TAB.TAB.$opt_name.TAB.($is_true ? "off" : "on")."\n");
    
    if ( FALSE == ($fdest = @fopen($output_folder.$app_file_name, "w")) ) 
    {
        $error_message = "could not open destination file ".$output_folder.$app_file_name."\n";
        return FALSE;
    }
    
    
    add_to_log(TAB."header\n");
    // writing header
    fwrite ($fdest,'<?php'."\n");
    
    // writing a comment about application
    fwrite ($fdest,"/*\n");
    fwrite ($fdest," * Application : $captures[project_name] \n");
    fwrite ($fdest," *\n");
    fwrite ($fdest," * creator     : \n");
    fwrite ($fdest," * created on  : ".date('Y-m-d')."\n");
    fwrite ($fdest," * version     : \n");  
    fwrite ($fdest," * license     : \n");    
    fwrite ($fdest," *\n");
    fwrite ($fdest," * created with: ".$GLOBALS['software_release_name']."\n");
    fwrite ($fdest," *             : ".$GLOBALS['software_url']."\n");
    fwrite ($fdest," */\n\n");
    
    if (FALSE != $options['print_debug'])
    {
        add_to_log(TAB."debug is on\n");
        
        // debuging
        fwrite ($fdest,"/*\n");
        fwrite ($fdest," * Debuging : set parameter to TRUE or FALSE\n");
        fwrite ($fdest," */\n\$_debug = TRUE;\n\n");

        // error_reporting
        fwrite ($fdest,"/*\n");
        fwrite ($fdest," * Error reporting. \n");
        fwrite ($fdest," *   Remeber to turn it on while developping,\n");
        fwrite ($fdest," *   it can avoid you to waste time and to have security holes\n");    
        fwrite ($fdest," */\n//error_reporting('E_ALL');\n\n");    
    }
    
    
    // loading php gtk
    add_to_log(TAB."php-gtk loader\n");    
    fwrite ($fdest,"/*\n");
    fwrite ($fdest," * Loading PHP-GTK extension\n");
    fwrite ($fdest," */\n");
    fwrite ($fdest,"if (!class_exists('gtk')) {\n");
    fwrite ($fdest,"\tif (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')\n");
    fwrite ($fdest,"\t{\n");
    fwrite ($fdest,"\t\tdl('php_gtk.dll');\n");
    fwrite ($fdest,"\t\t//\$_INI['os']\t= 'win';\n");
    fwrite ($fdest,"\t\t//\$_INI['new_line']\t= \"\\r\\n\";\n");
    fwrite ($fdest,"\t\t//\$_INI['folder_sep']\t= '\\';\n");    
    fwrite ($fdest,"\t}\n");    
    fwrite ($fdest,"\telse\n");
    fwrite ($fdest,"\t{\n");    
    fwrite ($fdest,"\t\tdl('php_gtk.so');\n");
    fwrite ($fdest,"\t\t//\$_INI['os']\t= 'lin';\n");
    fwrite ($fdest,"\t\t//\$_INI['new_line']\t= \"\\n\";\n");
    fwrite ($fdest,"\t\t//\$_INI['folder_sep']\t= '/';\n");    
    fwrite ($fdest,"\t}\n");    
    fwrite ($fdest,"}\n\n\n");
    
    // writing inclusions
    add_to_log(TAB."auto included files\n");    
    fwrite ($fdest,"/*\n");
    fwrite ($fdest," * Including files\n");
    fwrite ($fdest," */\n\n");
    foreach ($includes as $id => $filename)
    {
        fwrite ($fdest,"include('$filename');\n");
    }
    fwrite ($fdest,"\n\n");
    
    if (FALSE != $options['write_handlers'])
    {
        add_to_log(TAB."writing ".count($handlers)." signal functions\n");

        // writing all functions that are declared callbacks in glade file
        $parameters = '';
        fwrite ($fdest,"\n\n/************   GLADE application signal handlers **********************/\n\n");
        foreach ($handlers as $name => $handler_array)
        {
            add_to_log(TAB.TAB."- $handler_array[signal_handler]()\n");

            switch ($handler_array['widget_class'])
            {
                case 'GtkButton': $parameters = ' $button '; break;
                default: break; 
            }
            fwrite ($fdest,"/*\n *\n *\n *\n */\nfunction $handler_array[signal_handler]($parameters)\n{\n");

            if (FALSE != $options['print_debug'])
            {
                fwrite ($fdest,"\t\$_debug = &\$GLOBALS['_debug'];\n");
                fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
                fwrite ($fdest,"\t\techo \"signal ".$handler_array['signal_name']." called $handler_array[signal_handler]. function is line \".__LINE__.\"\\n\";\n");
            }
            fwrite ($fdest,"\t\n}\n\n");
            $parameters = '';
        }
    }

        
    if (FALSE != $options['write_extras'])
    {
        add_to_log(TAB."writing extra functions\n");

        fwrite ($fdest,"\n\n/************   Extra Functions use them if you whish **********************/\n\n");

        // writing quit app function
        add_to_log(TAB.TAB."- quit_app()\n");
        fwrite ($fdest,"/*\n *  Exit Application\n *\n *\n */\nfunction quit_app()\n{\n");
        fwrite ($fdest,"\t\$_debug    = &\$GLOBALS['_debug'];\n");
        fwrite ($fdest,"\t\n");    
        fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
        fwrite ($fdest,"\t\techo \"Leaving. Bye\\n\";\n");
        fwrite ($fdest,"\t\n");    
        fwrite ($fdest,"\tGtk::main_quit();\n");
        fwrite ($fdest,"}\n\n");


        // writing show_window function
        add_to_log(TAB.TAB."- show_window()\n");
        fwrite ($fdest,"/*\n *  Show window given in parameter\n *\n *\n */\nfunction show_window(\$window_name)\n{\n");
        fwrite ($fdest,"\t\$_debug    = &\$GLOBALS['_debug'];\n");
        fwrite ($fdest,"\t\$glade_app = &\$GLOBALS['glade_app'];\n");
        fwrite ($fdest,"\t\n");    
        fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
        fwrite ($fdest,"\t\techo \"showing window \$window_name\\n\";\n");
        fwrite ($fdest,"\t\$widget = \$glade_app->get_widget(\$window_name);\n");
        fwrite ($fdest,"\t\$widget->show();\n");
        fwrite ($fdest,"}\n\n");


        // writing hide_window function
        add_to_log(TAB.TAB."- hide_window()\n");
        fwrite ($fdest,"/*\n *  Hide Window given in paramter\n *\n *\n */\nfunction hide_window(\$window_name)\n{\n");
        fwrite ($fdest,"\t\$_debug    = &\$GLOBALS['_debug'];\n");
        fwrite ($fdest,"\t\$glade_app = &\$GLOBALS['glade_app'];\n");    
        fwrite ($fdest,"\t\n");    
        fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
        fwrite ($fdest,"\t\techo \"hiding window \$window_name\\n\";\n");
        fwrite ($fdest,"\t\$widget = \$glade_app->get_widget(\$window_name);\n");
        fwrite ($fdest,"\t\$widget->hide();\n");
        fwrite ($fdest,"}\n\n");


        // writing get_form function
        add_to_log(TAB.TAB."- get_form()\n");        
        fwrite ($fdest,"/*\n *  Return an array containing as key all user input widget name\n *\n *\n */\nfunction get_form(\$window_name)\n{\n");
        fwrite ($fdest,"\t\$_debug    = &\$GLOBALS['_debug'];\n");
        fwrite ($fdest,"\t\$glade_app = &\$GLOBALS['glade_app'];\n");
        fwrite ($fdest,"\t\n");    
        fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
        fwrite ($fdest,"\t\techo \"getting form values for \$window_name window\\n\";\n");
        fwrite ($fdest,"\t\n");
        fwrite ($fdest,"\tswitch (\$window_name)\n");
        fwrite ($fdest,"\t{\n");
        foreach ($windows as $windowid => $window_name)
        {
            fwrite ($fdest,"\t\tcase '$window_name':\n");
            fwrite ($fdest,"\t\t{\n");

            // this may trigger a notice while parsing if window
            // has no user editable widget. no matter
            $inputs = $user_change["$window_name"];

            if (FALSE != is_array($inputs))
            foreach ($inputs as $widget_type => $widget_list)
            {
                fwrite ($fdest,"\n\t\t\t/*\n");
                fwrite ($fdest,"\t\t\t * getting $widget_type\n");
                fwrite ($fdest,"\t\t\t */\n");
                if (FALSE != is_array($widget_list))
                foreach ($widget_list as $id => $input_name)
                {
                    //fwrite ($fdest,"\t\t\t// $input_name\n");
                    fwrite ($fdest,"\t\t\t\$widget = \$glade_app->get_widget('$input_name');\n");
                    switch ($widget_type)
                    {
                        case 'GtkCombo': // jump
                        case 'GtkEntry':
                        {
                            fwrite ($fdest,"\t\t\t\$ret['$input_name']\t = \$widget->get_text();\n");
                            break;
                        }
                        case 'GtkCheckButton' : // jump
                        case 'GtkRadioButton' : // jump
                        case 'GtkToggleButton':
                        {
                            fwrite ($fdest,"\t\t\t\$ret['$input_name']\t = \$widget->get_active();\n");
                            break;
                        }
                        /*
                        case '':
                        {
                                 $list->selection[0];
                            break;
                        }
                        */
                        default:
                        {
                            break;
                        }
                    }
                    fwrite ($fdest,"\t\t\t\n");            
                }
            }
            fwrite ($fdest,"\t\t\tbreak;\n"); // end case window_name
            fwrite ($fdest,"\t\t}\n"); // end case window_name
        }
        // default for switch
        fwrite ($fdest,"\t\tdefault: break;\n");
        // end switch
        fwrite ($fdest,"\t}\n"); 

        // writing return array value
        // end case window_name
        fwrite ($fdest,"\treturn \$ret;\n"); 
        // end function
        fwrite ($fdest,"}\n\n"); 




        // writing set_form function
        add_to_log(TAB.TAB."- set_form()\n");                
        fwrite ($fdest,"/*\n *  Set for a widget it's value contained in given array. only one window \n *\n *\n */\nfunction set_form(\$window_name, \$widget_values)\n{\n");
        fwrite ($fdest,"\t\$_debug    = &\$GLOBALS['_debug'];\n");
        fwrite ($fdest,"\t\$glade_app = &\$GLOBALS['glade_app'];\n");
        fwrite ($fdest,"\t\n");    
        fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
        fwrite ($fdest,"\t\techo \"setting widget values for \$window_name window\\n\";\n");
        fwrite ($fdest,"\t\n");
        fwrite ($fdest,"\tswitch (\$window_name)\n");
        fwrite ($fdest,"\t{\n");
        foreach ($windows as $windowid => $window_name)
        {
            fwrite ($fdest,"\t\tcase '$window_name':\n");
            fwrite ($fdest,"\t\t{\n");

            // this may trigger a notice while parsing if window
            // has no user editable widget. no matter
            $inputs = $user_change["$window_name"];

            if (FALSE != is_array($inputs))
            foreach ($inputs as $widget_type => $widget_list)
            {
                fwrite ($fdest,"\n\t\t\t/*\n");
                fwrite ($fdest,"\t\t\t * setting $widget_type\n");
                fwrite ($fdest,"\t\t\t */\n");
                if (FALSE != is_array($widget_list))
                foreach ($widget_list as $id => $input_name)
                {
                    //fwrite ($fdest,"\t\t\t// $input_name\n");
                    fwrite ($fdest,"\t\t\t\$widget = \$glade_app->get_widget('$input_name');\n");
                    switch ($widget_type)
                    {
                        case 'GtkEntry':
                        case 'GtkCombo': // jump
                        {
                            fwrite ($fdest,"\t\t\t\$widget->set_text(\$widget_values['$input_name']);\n");
                            break;
                        }
                        case 'GtkCheckButton' : // jump
                        case 'GtkRadioButton' : // jump
                        case 'GtkToggleButton':
                        {
                            fwrite ($fdest,"\t\t\t\$widget->set_active(\$widget_values['$input_name']);\n");
                            break;
                        }                    
                        default:
                        {
                            break;
                        }
                    }
                    fwrite ($fdest,"\t\t\t\n");            
                }
            }
            fwrite ($fdest,"\t\t\tbreak;\n"); // end case window_name
            fwrite ($fdest,"\t\t}\n"); // end case window_name
        }
        // default for switch
        fwrite ($fdest,"\t\tdefault: break;\n");
        // end switch
        fwrite ($fdest,"\t}\n"); 

        // writing return array value
        // end case window_name
        fwrite ($fdest,"\treturn \$ret;\n"); 
        // end function
        fwrite ($fdest,"}\n\n"); 
        
        
        // writing save_window_form_to_file() function
        add_to_log(TAB.TAB."- save_window_form_to_file() [not yet implemented]\n");                
        fwrite ($fdest,"/*\n *  Save a window form to a xml file \n *\n *\n */\nfunction save_window_form_to_file(\$window_name, \$filename)\n{\n");
        fwrite ($fdest,"\t\$_debug    = &\$GLOBALS['_debug'];\n");
        fwrite ($fdest,"\t\$glade_app = &\$GLOBALS['glade_app'];\n");
        fwrite ($fdest,"\t\n");    
        fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
        fwrite ($fdest,"\t\techo \"saving window form to file. function is line \".__LINE__.\"\\n\";\n");
        fwrite ($fdest,"\t\n");        
        fwrite ($fdest,"}\n\n");         
        
        // writing set_window_form_from_file() function
        add_to_log(TAB.TAB."- set_window_form_from_file() [not yet implemented]\n");
        fwrite ($fdest,"/*\n *  set a window form from a xml file \n *\n *\n */\nfunction set_window_form_from_file(\$window_name, \$filename)\n{\n");
        fwrite ($fdest,"\t\$_debug    = &\$GLOBALS['_debug'];\n");
        fwrite ($fdest,"\t\$glade_app = &\$GLOBALS['glade_app'];\n");
        fwrite ($fdest,"\t\n");    
        fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
        fwrite ($fdest,"\t\techo \"setting window values from file. function is line \".__LINE__.\"\\n\";\n");
        fwrite ($fdest,"\t\n");        
        fwrite ($fdest,"}\n\n");   
        
        // handles showing a dialog window for user informations (errors, notices, etc)
        add_to_log(TAB.TAB."- dialog_window_popup() [not yet implemented]\n");
        fwrite ($fdest,"/*\n *  Handles simple dialog windows \n *\n *\n */\nfunction dialog_window_popup(\$window_title, \$window_text)\n{\n");
        fwrite ($fdest,"\t\$_debug    = &\$GLOBALS['_debug'];\n");
        fwrite ($fdest,"\t\$glade_app = &\$GLOBALS['glade_app'];\n");
        fwrite ($fdest,"\t\n");    
        fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
        fwrite ($fdest,"\t\techo \"window popup. function is line \".__LINE__.\"\\n\";\n");
        fwrite ($fdest,"\t\n");        
        fwrite ($fdest,"}\n\n");
        
        // init_app() funtion
        if (FALSE != $options['write_init_app'])
        {
            add_to_log(TAB."init_app()\n");
            fwrite ($fdest,"/*\n *  initialize application. \n * allow you to hide windows at start of application and whatever else you want\n *\n *\n */\nfunction init_app()\n{\n");
            fwrite ($fdest,"\t\$_debug    = &\$GLOBALS['_debug'];\n");
            fwrite ($fdest,"\t\$glade_app = &\$GLOBALS['glade_app'];\n");
            fwrite ($fdest,"\t\n");    
            fwrite ($fdest,"\tif(FALSE != \$_debug)\n");
            fwrite ($fdest,"\t\techo \"Initializing...\\n\";\n");
            fwrite ($fdest,"\t\n");   
            foreach ($windows as $windowid => $window_name)
            {
                fwrite ($fdest,"\t//hide_window('$window_name');\n");
            }            
            fwrite ($fdest,"}\n\n");   
        }
        else add_to_log(TAB."not using init_app()\n");
        

    } // end of write_extras
    
    /*
     * writing php code to parse glade application
     */
    
    fwrite ($fdest,"\$glade_app = &new GladeXML('$src_file');\n");
    fwrite ($fdest,"\$glade_app->signal_autoconnect();\n");
    if (FALSE != $options['write_init_app'])
        fwrite ($fdest,"init_app();\n");
    fwrite ($fdest,"Gtk::main();\n?>");
    fclose ($fdest);
    
    if (FALSE != $_debug) add_to_log("done.\n");
    
    return TRUE;
    
}


/*
 * Writing a batch file for windows
 *
 */
function WriteBatFile()
{
    $_debug         = &$GLOBALS['_debug'];
    
    $_INI           = &$GLOBALS['_INI'];
    $captures       = &$GLOBALS['captures'];
    $app_file_name  = &$GLOBALS['app_file_name'];
    $output_folder  = &$GLOBALS['output_folder'];
    
    if (FALSE != $_debug) add_to_log("Writing windows bat file...");
        
    if (!($fdest = fopen($output_folder.$app_file_name.'.bat', "w"))) 
    {
        die("could not open destination file!\n");
        $return_value = FALSE;
    }
    else
    {
        fwrite($fdest,'@echo off'.$_INI['new_line']);
        fwrite($fdest,'cls'.$_INI['new_line']);
        fwrite($fdest,'echo '.$captures['project_name'].$_INI['new_line']);
        fwrite($fdest,'php.exe -q -e '.$app_file_name.$_INI['new_line']);
        fwrite($fdest,'pause');
        fclose($fdest);
        $return_value = TRUE;
    }
    
    if (FALSE != $_debug) add_to_log("done.\n");
    
    return $return_value;    
}


/***************************** LOG FUNCTIONS ***************************/

/*
 *  add to log text
 *
 */
function add_to_log($text)
{
    global $log_content;
    
    $glade_app    = &$GLOBALS['glade_app'];
    
    $log_widget = $glade_app->get_widget('text_log');
    
    // refresh must be stopped to edit content 
    $log_widget->freeze();
    
    // inserting at end of text (integer -1)
    $log_widget->insert_text($text,-1);
    
    $log_content .= $text;
    
    $log_widget->thaw();
    
}


/*
 *  clear log
 *
 */

function clear_log()
{
    $glade_app    = &$GLOBALS['glade_app'];
    
    $log_widget = $glade_app->get_widget('text_log');
    
    // refresh must be stopped to edit content 
    $log_widget->freeze();
    
    // inserting at end of text (integer -1)
    $log_widget->delete_text(0,-1);
    
    $log_widget->thaw();
}





/*
 *  copy log in clipboard
 *
 */

function copy_log_in_clipboard()
{
    $text = get_log_text();    
}



/*
 *  save log to a file 
 *
 */
function save_log($log_filename)
{
    $text = get_log_text();
    // writing file
}

/*
 *  auto save log saves log in output folder
 *
 */
function auto_save_log()
{
    $output_folder  = &$GLOBALS['output_folder'];
    $appname        = &$GLOBALS['appname'];
    $output_folder  = &$GLOBALS['output_folder'];
    
    $text = get_log_text();
    
    // writing file
    $log_file = $output_folder.$appname.'.log';
    if (FALSE == is_file($log_file))
    {
        $fp = fopen($log_file,'w');
        if (FALSE != $fp)
        {
            add_to_log('auto_save_log : '.$log_file.' written'."\n");
            fwrite($fp,$text);
            fclose($fp);
        }
        else
        {
            add_to_log('auto_save_log : Impossible to create log file'."\n".$log_file."\n");
            $error_message = 'Impossible to create log file'."\n".$log_file;
        }
    }
    else
    {
        add_to_log("auto_save_log : Impossible to write log, file\n".$log_file."\nalready exists!\n");
        $error_message = "Impossible to write log, file\n".$log_file."\nalready exists!\n";
    }
    
    return TRUE;
}


/*
 *  gets log text
 *
 */

function get_log_text()
{
    $glade_app    = &$GLOBALS['glade_app'];
    global $log_content;
    
    $log_widget = $glade_app->get_widget('text_log');
    
    // refresh must be stopped to edit content 
    $log_widget->freeze();
    
    $text = $log_content;
    
    $log_widget->thaw();
    
    return $text;
}


/*
 *  Save a window form to a xml file 
 *
 *
 */
function save_window_form_to_file($window_name, $filename='')
{
    $_debug    = &$GLOBALS['_debug'];
    $glade_app = &$GLOBALS['glade_app'];
    
    if (FALSE == $filename)
    {
        $filename = $window_name.'.xml';
    }
    
    $win_array = array();
    
    $xml_tab = '  ';
    
    $win_array = get_form($window_name);
    
    $fp = fopen ($filename,'w');
    
    if (FALSE != $fp)
    {
        fwrite($fp,'<?xml version="1.0"?>'."\n");
        fwrite($fp,'<window-value name="'.$window_name.'">'."\n");
        
        foreach ($win_array as $widget_name => $widget_value)
        {
            fwrite($fp,$xml_tab.'<'.$widget_name.'>'.$widget_value.'</'.$widget_name.'>'."\n");
        }
        fwrite($fp,'</window-value>'."\n");
        fclose($fp);
    }
    else echo "error, impossible to open file $filename\n";
    
}